	SUBROUTINE EDITCIRCL
C
C       This subroutine edits data within a circular area with the
C  center location being input by the TV cursor, manually, or from
C  a character file of type 2.  The center of the circle is taken to be 
C  the center of the pixel.  This produces a symmetric looking circle. 
C  The circle is displayed on the TV if you are using cursor input.
C  				Donald H. Gudehus, August, 1982
C				Version 2, Donald H. Gudehus, March, 1987
C				Added code for reading from a file of type 2
C				Version 3, Donald H. Gudehus, October, 1988
C				Added code for Trapix
C				Version 4, Donald H. Gudehus, August, 1993
C				Added code for SAOimage
C				Version 4U, Donald H. Gudehus, January 30, 2008
C				Converted to Unix and FITS
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*1 CHOICE
	CHARACTER*2 COMMAND,OPTION
	CHARACTER*3 PRGFMAT,FILEFMT
	CHARACTER*40 FILEKEYWORD
	CHARACTER*50 CHFITSMHV
	CHARACTER*80 FILENAME_IN
	COMMON /CHAR_SCRATCH_BLOCK/ CHOICE,COMMAND,OPTION
C
	INTEGER PLANEKEY,STATUS,MAPS_IN(MAPMAX)
	INTEGER LOCATION(2),COLUMN,ROW,DELTAHOR,RADIUS,DELTARADIUS,IQ(4),
	1OBJECT_TOTAL,ADDRESS
	INTEGER ACTION,CURSOR_TYPE,COLOR_TYPE
C	
	LOGICAL IOFL,MESS,FIRSTIME,PROCEED,OUTERAVERAGE
C
	REAL*4 R(3),DATA(MAXSIZE),INCLINA
C  R is the variable for radii of circles in TVCIR and for COMMAND='F'
C
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY$AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
C
	CHARACTER*6 ID
	COMMON /ID/ ID
C
	CHARACTER*80 DNAME
	LOGICAL EXTENDED
	COMMON /DFILE/ DNAME,EXTENDED
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL MESSAGE ('EDITCIRCL, Version 4')
C  Initialize location in case default is taken before updating
	LOCATION(1)=1
	LOCATION(2)=1
	MESS=.TRUE.
C
	LU_IN=11
	FILEKEYWORD='FILE='
	FILENAME_IN=' '
	IOFL=.TRUE.
	MAPKEY=0
	PLANEKEY=0
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME_IN,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
C  Create a temporary file.
	LU_TEMP=12
	MAPS_IN(1)=IMNUM
	NMAPS_IN=1
	CALL OPEN_TEMP_FITS(LU_IN,LU_TEMP,FILENAME_IN,MAPS_IN,NMAPS_IN,
	1NCOLS,NROWS,STATUS)
C
	COMMAND=' '
	DO WHILE (COMMAND.NE.'M'.AND.COMMAND.NE.'F'.AND.COMMAND.NE.'AS'
	1.AND.COMMAND.NE.'S')
	  CALL MESSAGE('Enter command:')
	  COMMAND='M'
	  IF (SAOIMAGE) THEN
	    CALL MESSAGE('     AS = Position from cursor;  SAOimage'//
	1   ' already loaded')
	    CALL MESSAGE('      S = Position from cursor;  need to'//
	1   ' load SAOimage')
	  END IF
	  CALL MESSAGE('      M = Manual input of position (default)')
	  CALL MESSAGE('      F = Input of all positions from charcter file'//
	1 ' of type 2')
	  CALL USRINP(%REF(COMMAND),2,'A',1,1,'COMMAND=',' ')
	  CALL ALPHA(%REF(COMMAND),1,2,NC,NF,NR,2)
	END DO
	CHOICE=' '
	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN !  Just for 
						    !  SAOimage for now
	  DO WHILE(CHOICE.NE.'A'.AND.CHOICE.NE.'M') 
	    CHOICE='M'
	    CALL MESSAGE('Enter a choice:')
	    CALL MESSAGE('     A = Automatic assignment of zero to pixel'//
	1   ' values for a fixed radius')
	    CALL USRINP(%REF(CHOICE),1,'A',1,1,'CHOICE=',
	1   '     M = Manual assignment of pixel values and radius (default)')
	  END DO
	  IF (CHOICE.EQ.'A') THEN
	    CALL USRINP(RADIUS,1,'I',4,0,'RADIUS=',
	1   'Enter the radius of the area to be set to zero:')
	  END IF
	END IF
C
C  Get set up for the selected command
C
	IF (COMMAND.EQ.'S') THEN
	  NPIC_SAO=1
	  IF (IFB_SAO.EQ.0) THEN
	    CALL SAOSTART
	    CALL SAOFIRST
	  ELSE
	    CALL SAOERAS
	  END IF
	  CALL SAODELS(LU_IN,1,0)
	ELSE IF (COMMAND.EQ.'F') THEN
	  IOCHFL=1
	  CALL MESSAGE('Open the character file of type 2 containing the'//
	1 ' positions and')
	  CALL MESSAGE('intensities of the objects to be edited.')
	  CALL OPENCF(21,IOCHFL,'FILE_21=',0)
	  CALL MESSAGE('Enter the desired radii of the edited circles'//
	1 ' for the faintest and ')
	  CALL USRINP(R,2,'F',4,0,'RADII=',
	1 'the brightest objects:  ')
	  CALL MESSAGE('Do you want to replace the pixel values by an'//
	1 ' average of pixels just')
	  OUTERAVERAGE=.FALSE.
	  CALL USRINP(OUTERAVERAGE,1,'L',1,1,'OUTER_AVERAGE=',
	1 'outside the circle?  (default = N)')
C  Read through the file to get the maximum and minimum intensities in order
C  to define the sizes of the edited circles.
	  IF (OUTERAVERAGE) THEN
	    DELTARADIUS=1
	    CALL USRINP(DELTARADIUS,1,'I',4,1,'DELTA_RADIUS=',
	1   'Enter the size of the outer annulus:  (default =1)')
	  END IF
	  REWIND(21)
	  READ(21,1200)
1200	  FORMAT(' ','ID',8X,'COLUMN',5X,'ROW',2X,'INCLINATION',
	1 1X,'ECCENTRICITY',1X,'FWHMA',5X,'FWHMB',1X,
	1 'QUADRANT CODE        PEAK             SKY')
	  OBJECT_TOTAL=0
	  PEAKMIN=1E37
	  PEAKMAX=0
	  DO WHILE (.TRUE.)
	    READ(21,1201,END=100) ID,X,Y,THETA,ECCENTR,FWHMA,FWHMB,(IQ(J),
	1   J=1,4),PEAK,SKY
1201	    FORMAT(' ',A6,1X,F9.3,1X,F9.3,1X,F7.2,6X,F6.3,1X,F9.3,1X,
	1   F9.3,3X,4I2,5X,G16.8,1X,G16.8)
	    OBJECT_TOTAL=OBJECT_TOTAL+1
	    IF (PEAK.LT.PEAKMIN) PEAKMIN=PEAK
	    IF (PEAK.GT.PEAKMAX) PEAKMAX=PEAK
	  END DO
 100	  REWIND(21)
	  READ(21,1200)
	  FIRSTIME=.TRUE.
	END IF
C
C  Loop for each object
C
	DO WHILE (.TRUE.)
C
C  Obtain the position and radius
C
	  IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	    PROCEED=.FALSE.
	    DO WHILE (.NOT.PROCEED)
	      IF (CHOICE.EQ.'A') THEN
  54	        CALL MESSAGE('Be sure SAOimage has focus, position the'//
	1       ' cursor, and then press <CR>;')
	        CALL MESSAGE('Type 0 or Q to quit')
	        CALL SAO_CURN(NPICN,IXN,IYN,XN,YN,XMN,YMN,KEY,MESS)
	        IF (KEY.EQ.13) THEN
	          IF (NPICN.EQ.0.OR.(NPICN.NE.0.AND.TV_FILENAME(NPICN)
	1         .NE.DNAME)) THEN
	            CALL MESSAGE('Try again')
	            GO TO 54
	          END IF
	          COLUMN=XMN
	          ROW=YMN
	          WRITE(6,1000) COLUMN,ROW
1000	          FORMAT(' ','The coordinates in the map are:  ',I5,3X,I5)
	          WRITE(7,1000) COLUMN,ROW
	        ELSE IF (KEY.EQ.48.OR.KEY.EQ.81) THEN
	          GO TO 999
	        ELSE
	          CALL BELL
	          CALL MESSAGE('You must press the <CR>!')
	          GO TO 54
	        END IF
	        PROCEED=.TRUE.
	        X=COLUMN+0.5
	        Y=ROW+0.5
	        NPIC1=NPICN
	        a=RADIUS
	        b=RADIUS
	        INCLINA=0.0
	        ACTION=2  ! Nonerasable cursor in region 
	        CURSOR_TYPE=1024  ! Circle
	        COLOR_TYPE=207  ! Yellow
	        CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1       a,b,INCLINA,EXTRA,0)
	      ELSE IF (CHOICE.EQ.'M') THEN
  55	        CALL MESSAGE('Be sure SAOimage has focus, position the'//
	1       ' cursor, and then press <CR>')
	        CALL MESSAGE('Type 0 or Q to quit')
	        CALL SAO_CURN(NPICN,IXN,IYN,XN,YN,XMN,YMN,KEY,MESS)
	        IF (KEY.EQ.13) THEN
	          IF (NPICN.EQ.0.OR.(NPICN.NE.0.AND.TV_FILENAME(NPICN)
	1         .NE.DNAME)) THEN
	            CALL MESSAGE('Try again')
	            GO TO 55
	          END IF
	          COLUMN=XMN
	          ROW=YMN
	          WRITE(6,1000) COLUMN,ROW
	          WRITE(7,1000) COLUMN,ROW
	        ELSE IF (KEY.EQ.48.OR.KEY.EQ.81) THEN
	          GO TO 999
	        ELSE
	          CALL BELL
	          CALL MESSAGE('You must press the <CR>!')
	          GO TO 55
	        END IF
	        CALL MESSAGE('Enter the radius of the area to be revalued:')
	        CALL USRINP(RADIUS,1,'I',4,0,'RADIUS=','(Enter 0 to quit)')
	        IF (RADIUS.EQ.0) GO TO 999
C  Draw the erasable circle cursor on SAOimage
	        ACTION=1
	        CURSOR_TYPE=1024 !  Circle
	        COLOR_TYPE=204 !  Red
	        X=COLUMN+0.5
	        Y=ROW+0.5
	        NPIC1=NPICN
	        a=RADIUS
	        b=RADIUS
	        INCLINA=0.0
	        CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1       a,b,INCLINA,EXTRA,0)
	        PROCEED=.TRUE.
	        CALL USRINP(PROCEED,1,'L',1,1,'PROCEED=',
	1       'Do you wish to proceed?  (default = Y)')
	        IF (PROCEED) THEN
	          ACTION=2 !  Nonerasable cursor in region 
	          CURSOR_TYPE=1024 !  Circle
	          COLOR_TYPE=207 !  Yellow
	          CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1         a,b,INCLINA,EXTRA,0)
	        ELSE IF (.NOT.PROCEED) THEN
C  Erase circle cursor
	          CALL SAO_ERASE_CURSOR(0)
	        END IF
	      END IF
	    END DO
	  ELSE IF (COMMAND.EQ.'M') THEN
	    CALL USRINP(LOCATION,2,'I',4,1,'LOCATION=',
	1   'Enter column and row:  (default = last entries;'//
	2   '  enter 0 to quit)')
	    IF (LOCATION(1).EQ.0) GO TO 999
	    COLUMN=LOCATION(1)
	    ROW=LOCATION(2)
	    CALL USRINP(RADIUS,1,'I',4,0,'RADIUS=',
	1   'Enter the radius of the area to be revalued:')
	  ELSE IF (COMMAND.EQ.'F') THEN
	    READ(21,1201,END=99) ID,X,Y,THETA,ECCENTR,FWHMA,FWHMB,(IQ(J),
	1   J=1,4),PEAK,SKY
	    COLUMN=INT(X)
	    ROW=INT(Y)
	    IF (PEAKMAX.NE.PEAKMIN) THEN
	      RADIUS=NINT(R(1)+(PEAK-PEAKMIN)/(PEAKMAX-PEAKMIN)*
	1     (R(2)-R(1)))
	    ELSE !  Probably only one object in file
	      RADIUS=R(1)
	    END IF
	  END IF
C
C  Get the value and write it
C
	  IF (COMMAND.NE.'F') THEN
	    VALUE=0.0
	    IF (CHOICE.NE.'A') THEN
	      CALL USRINP(VALUE,1,'F',4,1,'VALUE=',
	1     'Enter the new value:  (default = 0)')
	    END IF
	  ELSE
	    IF (.NOT.OUTERAVERAGE) THEN
	      IF (FIRSTIME) THEN
	        VALUE=0.0
	        CALL USRINP(VALUE,1,'F',4,1,'VALUE=',
	1       'Enter the new value:  (default = 0)')
	        FIRSTIME=.FALSE.
	      END IF
	    ELSE
C  If an outer average is to be computed, we must set all edited areas equal
C  to zero before computing an average from an outer circle of pixels
	      VALUE=0.0
	    END IF
	  END IF
	  DO J=MIN0(NROWS,MAX0(1,ROW-RADIUS)),
	1 MAX0(1,MIN0(NROWS,ROW+RADIUS))
	    CALL RDFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,J)
	    IF (J.LE.ROW) THEN
	      DELTAHOR=JINT(SQRT(RADIUS**2-(ROW-J-0.5)**2)+0.5)
	    ELSE
	      DELTAHOR=JINT(SQRT(RADIUS**2-(ROW-J+0.5)**2)+0.5)
	    END IF
	    DO I=MIN0(NCOLS,MAX0(1,COLUMN-DELTAHOR)),
	1   MAX0(1,MIN0(NCOLS,COLUMN+DELTAHOR))
	      DATA(I)=VALUE
	    END DO
	    CALL WRFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,J)
	  END DO
	END DO
C  Compute the outer average if required for command 'F'
  99	IF (COMMAND.EQ.'F'.AND.OUTERAVERAGE) THEN
	  REWIND (21)
	  READ(21,1200)
	  DO WHILE (.TRUE.)
	    READ(21,1201,END=999) ID,X,Y,THETA,ECCENTR,FWHMA,FWHMB,(IQ(J),
	1   J=1,4),PEAK,SKY
	    COLUMN=INT(X)
	    ROW=INT(Y)
	    IF (PEAKMAX.NE.PEAKMIN) THEN
	      RADIUS=NINT(R(1)+(PEAK-PEAKMIN)/(PEAKMAX-PEAKMIN)*
	1    (R(2)-R(1)))
	    ELSE !  Probably only one object in file
	      RADIUS=R(1)
	    END IF
C  Get the average from the annulus
	    MNCOLUMN=MAX(1,COLUMN-RADIUS-DELTARADIUS)
	    MNROW=MAX(1,ROW-RADIUS-DELTARADIUS)
	    NCOL=MIN(NCOLS,COLUMN+RADIUS+DELTARADIUS)-MNCOLUMN+1
	    NROW=MIN(NROWS,ROW+RADIUS+DELTARADIUS)-MNROW+1
	    LENGTH=NCOL*NROW
	    CALL DYNAMIC(ADDRESS,LENGTH,'  R4',.TRUE.)
	    CALL EDITCIRCL1(%VAL(ADDRESS),NCOL,NROW,COLUMN,ROW,MNCOLUMN,MNROW,
	1   RADIUS,DELTARADIUS,VALUE)
	    DO J=MIN0(NROWS,MAX0(1,ROW-RADIUS)),MAX0(1,MIN0(NROWS,ROW+RADIUS))
	      CALL RDFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,J)
	      IF (J.LE.ROW) THEN
	        DELTAHOR=JINT(SQRT(RADIUS**2-(ROW-J-0.5)**2)+0.5)
	      ELSE
	        DELTAHOR=JINT(SQRT(RADIUS**2-(ROW-J+0.5)**2)+0.5)
	      END IF
	      DO I=MIN0(NCOLS,MAX0(1,COLUMN-DELTAHOR)),
	1     MAX0(1,MIN0(NCOLS,COLUMN+DELTAHOR))
	        DATA(I)=VALUE
	      END DO
	      CALL WRFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,J)
	    END DO
	  END DO
	END IF
C
C  Exit
 999	LU_OUT=13
	CALL SAVE_SAVE_AS(LU_IN,LU_TEMP,LU_OUT,MAPS_IN,NMAPS_IN,STATUS)
C  If SAOimage was used, erase the region circles
	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	  CALL SAO_ERASE_CURSOR(1)
	END IF
	IF (COMMAND.EQ.'F') THEN
	  WRITE(6,2000) OBJECT_TOTAL
2000	  FORMAT(' ','A total of',I5,' objects were edited')
	  WRITE(7,2000) OBJECT_TOTAL
	  CLOSE(21)
	END IF
	RETURN
	END
