	SUBROUTINE EDITPOINT
C
C       This subroutine edits data, one point at a time with locations
C  being input by the TV cursor or manually.
C			Donald H. Gudehus, August, 1982
C			Version 2, Donald H. Gudehus, November, 1988
C			Added code for Trapix
C			Version 3, Donald H. Gudehus, August, 1993
C			Added code for SAOimage
C			Version 3U, Donald H. Gudehus, January 27, 2008
C			Converted the code to Unix and FITS
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*1 CHOICE
	CHARACTER*2 COMMAND
	CHARACTER*3 PRGFMAT,FILEFMT
	CHARACTER*40 FILEKEYWORD
	CHARACTER*50 CHFITSMHV
	CHARACTER*80 FILENAME_IN
C
	INTEGER*4 COLUMN,ROW,LOCATION(2)
	INTEGER PLANEKEY,STATUS
	INTEGER MAPS_IN(MAPMAX)
	LOGICAL IOFL,MESS,SP,DP
	REAL*4 DATA(MAXSIZE),VALUE
	REAL*8 DATADP(MAXSIZE),VALUEDP
C
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY_AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
C
	CHARACTER*80 DNAME
	LOGICAL EXTENDED
	COMMON /DFILE/ DNAME,EXTENDED
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL MESSAGE ('EDITPOINT, Version 3')
C  Initialize location in case default is taken before updating
	COLUMN=1
	ROW=1
	MESS=.TRUE.
	SP=.FALSE.
	DP=.FALSE.
C
	LU_IN=11
	FILEKEYWORD='FILE='
	FILENAME_IN=' '
	IOFL=.TRUE.
	MAPKEY=0
	PLANEKEY=0
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME_IN,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	COMMAND=' '
C  Create a temporary file.
	LU_TEMP=12
	MAPS_IN(1)=IMNUM
	NMAPS_IN=1
	CALL OPEN_TEMP_FITS(LU_IN,LU_TEMP,FILENAME_IN,MAPS_IN,NMAPS_IN,
	1NCOLS,NROWS,STATUS)
C
	DO WHILE (COMMAND.NE.'M'.AND.COMMAND.NE.'AS'.AND.COMMAND.NE.'S')
	  CALL MESSAGE('Enter command:')
	  COMMAND='M'
	  IF (SAOIMAGE) THEN
	    CALL MESSAGE('     AS = Position from cursor;  SAOimage '//
	1   'already loaded')
	    CALL MESSAGE('      S = Position from cursor;  need to '//
	1   'load SAOimage')
	  END IF
	  CALL USRINP(%REF(COMMAND),2,'A',1,1,'COMMAND=',
	1 '      M = Manual input of position (default)')
	  CALL ALPHA(%REF(COMMAND),1,2,NC,NF,NR,2)
	END DO
	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	  CHOICE='A'
	  CALL MESSAGE('Enter a choice:')
	  CALL MESSAGE('     A = Automatic assignment of zero to pixel '//
	1 'value (default)')
	  CALL MESSAGE('     B = Automatic assignment of user value to '//
	1 'pixel value')
	  CALL USRINP(%REF(CHOICE),1,'A',1,1,'CHOICE=',
	1 '     M = Manual assignment of each pixel value')
	END IF
	IF (COMMAND.EQ.'S') THEN
	  NPIC_SAO=1
	  IF (IFB_SAO.EQ.0) THEN
	    CALL SAOSTART
	    CALL SAOFIRST
	  ELSE
	    CALL SAOERAS
	  END IF
	  CALL SAODELS(LU_IN,1,0)
	END IF
	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	  IF (CHOICE.EQ.'A'.OR.CHOICE.EQ.'B') THEN
	    IF (CHOICE.EQ.'B') THEN
	      CALL USRINP(VALUEDP,1,'F',8,0,'VALUE=',
	1     'Enter the new assigned value:')
	    END IF
  55	    CALL MESSAGE('Be sure SAOimage has focus, position the '//
	1   'cursor, and then press <CR>')
	    CALL MESSAGE('(type 0 or Q to quit)')
	    CALL SAO_CURN(NPICN,IXN,IYN,XN,YN,XMN,YMN,KEY,MESS)
	    IF (KEY.EQ.13) THEN
	      IF (NPICN.EQ.0.OR.(NPICN.NE.0.AND.TV_FILENAME(NPICN)
	1     .NE.DNAME)) THEN
	        CALL MESSAGE('Try again')
	        GO TO 55
	      END IF
	      COLUMN=XMN
	      ROW=YMN
C  Draw the point on SAOimage
	      CALL SAODOT(INT(XMN),INT(YMN),NPICN,207)
	    ELSE IF (KEY.EQ.48.OR.KEY.EQ.81) THEN
	      GO TO 900
	    ELSE
	      CALL BELL
	      CALL MESSAGE('You must press the <CR>, 0, or Q!')
	      GO TO 55
	    END IF
	  ELSE !  M
  60	    CALL MESSAGE('Be sure SAOimage has focus, position the '//
	1   'cursor, and then press <CR>')
	    CALL MESSAGE('(type 0 or Q to quit)')
	    CALL SAO_CURN(NPICN,IXN,IYN,XN,YN,XMN,YMN,KEY,MESS)
	    IF (KEY.EQ.13) THEN
	      IF (NPICN.NE.NPIC_SAO) THEN
	        CALL MESSAGE('Try again')
	        GO TO 60
	      END IF
	      IF (TV_FILENAME(NPICN).NE.DNAME) THEN
	        CALL MESSAGE('Wrong image for requested file')
	        GO TO 60
	      END IF
	      COLUMN=XMN
	      ROW=YMN
C  Draw the point on SAOimage
	      CALL SAODOT(INT(XMN),INT(YMN),NPICN,207)
	    ELSE IF (KEY.EQ.48.OR.KEY.EQ.81) THEN
	      GO TO 900
	    ELSE
	      CALL BELL
	      CALL MESSAGE('You must press the <CR>, 0, or Q!')
	      GO TO 60
	    END IF
	  END IF
	END IF
	IF (COMMAND.EQ.'M') THEN
 500	  CALL USRINP(LOCATION,2,'I',4,1,'LOCATION=',
	1 'Enter the column and row:  (default = last entry;  '// 
	2 'enter 0 to quit)')
	  IF (LOCATION(1).EQ.0) GO TO 900
	  COLUMN=LOCATION(1)
	  ROW=LOCATION(2)
	END IF
C  Read and then write
	FILEFMT=CHFITSMHV(LU_IN,IMNUM,'BITPIX','R4')
	IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	  SP=.TRUE.
	  CALL RDFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,ROW)
1000	  FORMAT(' ','Value at location X =',I4,'   Y =',I4,'   is',G20.13)
	  WRITE(6,1000) COLUMN,ROW,DATA(COLUMN)
	  WRITE(7,1000) COLUMN,ROW,DATA(COLUMN)
	ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	  DP=.TRUE.
	  CALL RDDPFITSROW(LU_TEMP,IMNUM,IPNUM,DATADP,MAXSIZE,ROW)
	  WRITE(6,1000) COLUMN,ROW,DATADP(COLUMN)
	  WRITE(7,1000) COLUMN,ROW,DATADP(COLUMN)
	END IF
C  Write
	IF ((COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S')
	1.AND.(CHOICE.EQ.'A'.OR.CHOICE.EQ.'B')) THEN
	  IF (CHOICE.EQ.'A') THEN
	    IF (SP) THEN
	      DATA(COLUMN)=0.0
	    ELSE IF (DP) THEN
	      DATADP(COLUMN)=0.0D0
	    END IF
	  ELSE IF (CHOICE.EQ.'B') THEN
	    IF (SP) THEN
	      DATA(COLUMN)=VALUEDP
	    ELSE IF (DP) THEN
	      DATADP(COLUMN)=VALUEDP
	    END IF
	  END IF
	ELSE !  COMMAND equals M, or (COMMAND equals AS, or S,
	     !  and CHOICE equals M
	  IF (SP) THEN
	    VALUE=DATA(COLUMN)
	    CALL USRINP(VALUE,1,'F',4,1,'VALUE=',
	1   'Enter the new value:  (default = old value)')
	    DATA(COLUMN)=VALUE
	  ELSE IF (DP) THEN
	    VALUEDP=DATADP(COLUMN)
	    CALL USRINP(VALUDDP,1,'F',8,1,'VALUE=',
	1   'Enter the new value:  (default = old value)')
	    DATADP(COLUMN)=VALUEDP
	  END IF
	END IF
	IF (SP) THEN
	  CALL WRFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,ROW)
	ELSE IF (DP) THEN
	  CALL WRDPFITSROW(LU_TEMP,IMNUM,IPNUM,DATADP,MAXSIZE,ROW)
	END IF
C  Recycle
	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	  IF (CHOICE.EQ.'A'.OR.CHOICE.EQ.'B') GO TO 55
	  IF (CHOICE.EQ.'M') GO TO 60
	ELSE !  COMMAND equals M
	  GO TO 500
	END IF
 900	LU_OUT=13
	CALL SAVE_SAVE_AS(LU_IN,LU_TEMP,LU_OUT,MAPS_IN,NMAPS_IN,STATUS)
	RETURN
	END
