	SUBROUTINE EDITRECT
C
C       This subroutine edits data within a rectangular area with the
C  boundaries being input by the TV cursor box or manually.
C			Donald H. Gudehus, August, 1982
C			Version 2, Donald H. Gudehus, November, 1988
C			Added code for Trapix
C			Version 3, Donald H. Gudehus, August, 1993
C			Added code for SAOimage.
C			Version 4, Donald H. Gudehus, November 7, 2000
C			Added call to SAO_ERASE_CURSOR so that yellow box
C			would consistently appear after red box was drawn.
C			Version 4U, Donald H. Gudehus, January 28, 2008
C			Converted the code to Unix and FITS
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*2 COMMAND
	CHARACTER*3 PRGFMAT,FILEFMT
	CHARACTER*40 FILEKEYWORD
	CHARACTER*50 CHFITSMHV
	CHARACTER*80 FILENAME_IN
C
	INTEGER*2 IX1,IY1,IX2,IY2
	INTEGER IXM1,IYM1,IXM2,IYM2
	INTEGER PLANEKEY,STATUS,ISZ(4)
	INTEGER MAPS_IN(MAPMAX)
	INTEGER ACTION,CURSOR_TYPE,COLOR_TYPE
C
	LOGICAL IOFL,PROCEED
C
	REAL*4 DATA(MAXSIZE),VALUE,INCLINA
	REAL*8 DATADP(MAXSIZE),VALUEDP
C
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY_AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
C
	CHARACTER*80 DNAME
	LOGICAL EXTENDED
	COMMON /DFILE/ DNAME,EXTENDED
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL MESSAGE ('EDITRECT, Version 4')
C  Initialize XM1 to avoid quitting subroutine
	XM1=1.0
	LU_IN=11
	FILEKEYWORD='FILE='
	FILENAME_IN=' '
	IOFL=.TRUE.
	MAPKEY=0
	PLANEKEY=0
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME_IN,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	COMMAND=' '
C  Create a temporary file.
	LU_TEMP=12
	MAPS_IN(1)=IMNUM
	NMAPS_IN=1
	CALL OPEN_TEMP_FITS(LU_IN,LU_TEMP,FILENAME_IN,MAPS_IN,NMAPS_IN,
	1NCOLS,NROWS,STATUS)
C
	COMMAND=' '
	DO WHILE (COMMAND.NE.'AS'.AND.COMMAND.NE.'S'
	1.AND.COMMAND.NE.'M')
	  CALL MESSAGE('Enter a command:')
	  COMMAND='M'
	  IF (SAOIMAGE) THEN
	    CALL MESSAGE('     AS = Position from cursor;  SAOimage '//
	1   'already loaded')
	    CALL MESSAGE('      S = Position from cursor;  need to '//
	1   'load SAOimage')
	  END IF
	  CALL MESSAGE('      M = Manual input of boundaries (default)')
	  CALL USRINP(%REF(COMMAND),1,'A',2,1,'COMMAND=',' ')
	  CALL ALPHA(%REF(COMMAND),1,2,NC,NF,NR,2)
	END DO
	IF (COMMAND.EQ.'S') THEN
	  NPIC_SAO=1
	  IF (IFB_SAO.EQ.0) THEN
	    CALL SAOSTART
	    CALL SAOFIRST
	  ELSE
	    CALL SAOERAS
	  END IF
	  CALL SAODELS(LU_IN,1,0)
	END IF
	DO WHILE (.TRUE.) !  Main loop
	  IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	    PROCEED=.FALSE.
	    DO WHILE (.NOT.PROCEED)
	      MODE=1 !  Gives prompt for quiting
	      CALL SAO2CUR(MODE,IX1,IY1,IX2,IY2,X1,Y1,X2,Y2,XM1,YM1,XM2,YM2,
	1     NPIC1,KEY,X,Y,a,b)
	      IF (KEY.EQ.48.OR.KEY.EQ.81) GO TO 999 !  User instigated quit
	      PROCEED=.TRUE.
	      CALL USRINP(PROCEED,1,'L',1,1,'PROCEED=',
	1     'Do you wish to proceed?  (default = Y)')
	      IF (PROCEED) THEN
C  Erase the red box so that the yellow one will appear
	        CALL SAO_ERASE_CURSOR(0)
C  Write vectors onto SAOimage (not erasable)
	        ACTION=2  ! Non erasable cursor
	        CURSOR_TYPE=768  ! Rectangle
	        COLOR_TYPE=207  ! Yellow
	        CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1       a,b,INCLINA,EXTRA,0)
	      ELSE IF (.NOT.PROCEED) THEN
C  Erase rectangle cursor
	        CALL SAO_ERASE_CURSOR(0)
	      END IF 
	    END DO
	  ELSE IF (COMMAND.EQ.'M') THEN
	    CALL USRINP(ISZ,4,'I',4,0,'BOUNDARIES=',
	1   'Enter start-column end-column start-row end-row:  '//
	2   '(enter 0 to quit)')
	    XM1=ISZ(1)
	    XM2=ISZ(2)
	    YM1=ISZ(3)
	    YM2=ISZ(4)
	    IF (XM1.EQ.0) GO TO 999
	  END IF
	  IXM1=INT(XM1)
	  IXM2=INT(XM2)
	  IYM1=INT(YM1)
	  IYM2=INT(YM2)
	  FILEFMT=CHFITSMHV(LU_IN,IMNUM,'BITPIX','R4')
	  IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1 FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	    VALUE=0.0
	    CALL USRINP(VALUE,1,'F',4,1,'VALUE=',
	1   'Enter the new value:  (default = 0)')
	    DO J=IYM1,IYM2
	      CALL RDFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,J)
	      DO I=IXM1,IXM2
	        DATA(I)=VALUE
	      END DO
	      CALL WRFITSROW(LU_TEMP,IMNUM,IPNUM,DATA,MAXSIZE,J)
	    END DO
	  ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	    VALUEDP=0.0D0
	    CALL USRINP(VALUEDP,1,'F',8,1,'VALUE=',
	1   'Enter the new value:  (default = 0)')
	    DO J=IYM1,IYM2
	      CALL RDDPFITSROW(LU_TEMP,IMNUM,IPNUM,DATADP,MAXSIZE,J)
	      DO I=IXM1,IXM2
	        DATADP(I)=VALUEDP
	      END DO
	      CALL WRDPFITSROW(LU_TEMP,IMNUM,IPNUM,DATADP,MAXSIZE,j)
	    END DO
	  END IF
	END DO
 999	LU_OUT=13
	CALL SAVE_SAVE_AS(LU_IN,LU_TEMP,LU_OUT,MAPS_IN,NMAPS_IN,STATUS)
C  If SAOimge was used, erase the cursor (the drawing can't be erased).
	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	  CALL SAO_ERASE_CURSOR(0)
	END IF
	RETURN
	END
