	SUBROUTINE AVERSIG(DAT,NX,NY,IS,JS,IF,JF,EXCLUDE,AVG,SIGMA)
C
C       This subroutine finds the average and mean error of the two-
C  dimensional array DAT.
C			Donald H. Gudehus, January, 1984
C
C	DAT	(C)	The array for the data
C	NX	(C)	The dimension of the array DAT in the x
C			direction
C	NY	(C)	The dimension of the array DAT in the y
C			direction
C	IS	(C)	The starting index in the x direction
C	JS	(C)	The starting index in the y direction
C	IF	(C)	The ending index in the x direction
C	JF	(C)	The ending index in the y direction
C	EXCLUDE	(C)	A key which if true will exclude zero values
C			from the computation
C	AVG	(R)	The average
C	SIGMA	(R)	The mean error
C
	DIMENSION DAT(NX,NY)
	LOGICAL EXCLUDE
	REAL*8 SUM,AVG,SIGMA
	REAL*4 NUMPIXELS
C
	SUM=0.0D0
	NUMPIXELS=0.0
	DO M=JS,JF
	  DO L=IS,IF
	    IF ((EXCLUDE.AND.DAT(L,M).NE.0.0).OR..NOT.EXCLUDE) THEN
	      SUM=SUM+DAT(L,M)
	      NUMPIXELS=NUMPIXELS+1.0
	    END IF
	  END DO
	END DO
	IF (NUMPIXELS.GT.0) THEN
	  AVG=SUM/NUMPIXELS
	ELSE
	  CALL ERROR(-3,'No pixels of acceptable value')
	END IF
	SUM=0.0D0
	DO M=JS,JF
	  DO L=IS,IF
	    IF ((EXCLUDE.AND.DAT(L,M).NE.0.0).OR..NOT.EXCLUDE) THEN
	      SUM=SUM+(DAT(L,M)-AVG)**2
	    END IF
	  END DO
	END DO
	SIGMA=SQRT(SUM/(MAX(1.0,NUMPIXELS-1.0)))
	RETURN
	END
