	SUBROUTINE COFACTOR(MATRIX,MINORARRAY,SIZE,ROW,COLUMN,
	1ORDER,MINOR,SIGN,KPVT)
C
C       This subroutine computes the minor of the input matrix
C  and the sign.  The signed minor is the cofactor.  Note that the
C  order of indexes is row, column which is backwards from indexes
C  for pictures and cartesian coordinates.
C				Donald H. Gudehus, September, 1982
C
C	MATRIX		(C)	The array of the matrix
C	MINORARRAY	(R)	The minor array
C	SIZE		(C)	The dimension of MATRIX and MINORARRAY
C				as defined in the calling routine.
C	ROW		(C)	The row defining the minor
C	COLUMN		(C)	The column defining the minor
C	ORDER		(C)	The order of the matrix in the array
C				MATRIX
C	MINOR		(R)	The minor of the determinant of the
C				matrix.  The minor = MINOR(1)*10**
C				MINOR(2)
C	SIGN		(R)	The sign of the cofactor
C	KPVT		(R)	A vector of pivot indices
C
	INTEGER*4 ROW,COLUMN,SIZE,ORDER,KPVT(SIZE),ADDRESS1,ADDRESS2
	REAL*8 MATRIX(SIZE,SIZE),MINORARRAY(SIZE,SIZE),
	1MINOR(2),SIGN
C
C  Create some dynamic memory
	CALL DYNAMIC(ADDRESS1,ORDER,'  R8',.TRUE.)
	CALL DYNAMIC(ADDRESS2,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	CALL COFACTOR1(MATRIX,MINORARRAY,SIZE,ROW,COLUMN,ORDER,
	1MINOR,SIGN,KPVT,%VAL(ADDRESS1),%VAL(ADDRESS2))
	CALL DYNAMIC(ADDRESS1,ORDER,'  R8',.FALSE.)
	CALL DYNAMIC(ADDRESS2,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
C
	RETURN
	END
