	SUBROUTINE COFACTOR1(MATRIX,MINORARRAY,SIZE,ROW,COLUMN,ORDER,
	1MINOR,SIGN,KPVT,WORK,AP)
C
C	Note:  This is the Unix version.
C
C       This subroutine helps COFACTOR to calculate the cofactor of
C  MATRIX.
C			Donald H. Gudehus, April, 1986
C			Version 1U, D. H. G., September 16, 1999
C			Modified call to DSPDI for Unix
C
C	MATRIX		(C)	The array of the matrix
C	MINORARRAY	(R)	The minor array
C	SIZE		(C)	The dimension of MATRIX and MINORARRAY
C				as defined in the calling routine.
C	ROW		(C)	The row defining the minor
C	COLUMN		(C)	The column defining the minor
C	ORDER		(C)	The order of the matrix in the array
C				MATRIX
C	MINOR		(R)	The minor of the determinant of the
C				matrix.  The minor = MINOR(1)*10**
C				MINOR(2)
C	SIGN		(R)	The sign of the cofactor
C	KPVT		(R)	A vector of pivot indices
C	WORK		(R)	A working array
C	AP		(R)	A working array for the upper triangular
C				part of MATRIX
C
	INTEGER*4 ROW,COLUMN,SIZE,ORDER,KPVT(SIZE),INERTIA(3)
	REAL*8 MATRIX(SIZE,SIZE),MINORARRAY(SIZE,SIZE),WORK(ORDER),
	1AP(ORDER*(ORDER+1)/2),MINOR(2),SIGN
C  Initialize INERTIA (which is not used here)
	INERTIA(1)=0
	INERTIA(2)=0
	INERTIA(3)=0
C  Load the minor array;  I and J are the output minor indexes
C  and II and JJ are the input matrix indexes.
	DO J=1,ORDER-1
	  JJ=J
	  IF (J.GE.COLUMN) JJ=J+1
	  DO I=1,ORDER-1
	    II=I
	    IF (I.GE.ROW) II=I+1
	    MINORARRAY(I,J)=MATRIX(II,JJ)
	  END DO
	END DO
	IF (COLUMN.EQ.ROW) THEN
C  Load the array AP with the upper right triangular part of the matrix
	  K=0
	  DO I=1,ORDER-1
	    DO J=1,I
	      K=K+1
	      AP(K)=MINORARRAY(J,I)
	    END DO
	  END DO
	  JOB=10  ! Solve for the determinant only
	  CALL DSPFA(AP,ORDER-1,KPVT,INFO)
	  CALL DSPDI(AP,ORDER-1,KPVT,MINOR,INERTIA,WORK,JOB)
C  Note that the minor equals MINOR(1)*10.0**MINOR(2)
	ELSE
	  CALL MESSAGE('Assymetric determinant routine not yet'//
	1' available')
	  RETURN
	END IF
C  Get the sign
	SIGN=(-1.0D0)**(COLUMN+ROW)
	RETURN
	END

