	SUBROUTINE FIND1(LU_IN,ARRAY,ARRAY2,NII,NJJ,ROWARRAY,ISIZE,
	1SKY_PARAMETERS,K_SIGMA,OBJDIAM)
C
C       This subroutine helps FIND by allowing operation of the
C  the dynamic memory assignment.
C			Donald H. Gudehus, January, 1987
C			Version 1U, Donald H. Gudehus, February 17, 2008
C			Converted to Unix and FITS and removed code for
C			Grinnell and Trapix
C
	INCLUDE 'miipspar.for'
C
	INTEGER LU_IN,ISIZE(4),NII,NJJ,OBJDIAM
C
	REAL ARRAY(NII,NJJ),ARRAY2(NII,NJJ),ROWARRAY(MAXSIZE),
	1SKY_PARAMETERS(2),K_SIGMA
C
	INTEGER IQ(4)
C
	REAL ARRAY2MAX
C
	CHARACTER*6 ID
	COMMON /ID/ ID
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
C  Read the array from the map
	CALL RDFITSXY(LU_IN,IMNUM,IPNUM,ARRAY,NII,NJJ,ISIZE(1),NII,
	1ISIZE(3),NJJ)
C  Scan through the first array to identify which pixels pass the k-sigma test
	DO J=1,NJJ
	  DO I=1,NII
	    IF ((ARRAY(I,J)-SKY_PARAMETERS(1)).GE.K_SIGMA*SKY_PARAMETERS(2))
	1   THEN
	      ARRAY2(I,J)=ARRAY(I,J)
	    ELSE
	      ARRAY2(I,J)=0.0
	    END IF
	  END DO
	END DO
	IF (OBJDIAM.EQ.1) GO TO 100
C  Scan through the second array with an array the size of the object.  Find
C  the local maximum
	DO J=1,NJJ-OBJDIAM+1,OBJDIAM/3
	  DO I=1,NII-OBJDIAM+1,OBJDIAM/3
	    ARRAY2MAX=0
	    DO JJ=J,J+OBJDIAM-1
	      DO II=I,I+OBJDIAM-1
	        IF (ARRAY2(II,JJ).GT.ARRAY2MAX) THEN
	          ARRAY2MAX=ARRAY2(II,JJ)
	          IMAX=II
	          JMAX=JJ
	        END IF
	      END DO
	    END DO
C  Set the other values equal to zero
	    IF (ARRAY2MAX.NE.0) THEN
	      DO JJ=J,J+OBJDIAM-1
	        DO II=I,I+OBJDIAM-1
	          IF (II.NE.IMAX.OR.JJ.NE.JMAX) THEN
	            ARRAY2(II,JJ)=0.0
	          END IF
	        END DO
	      END DO
	    END IF
	  END DO
	END DO
C  Do the top edge in case it was missed
	J=NJJ-OBJDIAM+1
	DO I=1,NII-OBJDIAM+1,OBJDIAM/3
	  ARRAY2MAX=0
	  DO JJ=J,J+OBJDIAM-1
	    DO II=I,I+OBJDIAM-1
	      IF (ARRAY2(II,JJ).GT.ARRAY2MAX) THEN
	        ARRAY2MAX=ARRAY2(II,JJ)
	        IMAX=II
	        JMAX=JJ
	      END IF
	    END DO
	  END DO
C  Set the other values equal to zero
	  IF (ARRAY2MAX.NE.0) THEN
	    DO JJ=J,J+OBJDIAM-1
	      DO II=I,I+OBJDIAM-1
	        IF (II.NE.IMAX.OR.JJ.NE.JMAX) THEN
	          ARRAY2(II,JJ)=0.0
	        END IF
	      END DO
	    END DO
	  END IF
	END DO
C  Do the right edge in case it was missed
	I=NII-OBJDIAM+1
	DO J=1,NJJ-OBJDIAM+1,OBJDIAM/3
	  ARRAY2MAX=0
	  DO JJ=J,J+OBJDIAM-1
	    DO II=I,I+OBJDIAM-1
	      IF (ARRAY2(II,JJ).GT.ARRAY2MAX) THEN
	        ARRAY2MAX=ARRAY2(II,JJ)
	        IMAX=II
	        JMAX=JJ
	      END IF
	    END DO
	  END DO
C  Set the other values equal to zero
	  IF (ARRAY2MAX.NE.0) THEN
	    DO JJ=J,J+OBJDIAM-1
	      DO II=I,I+OBJDIAM-1
	        IF (II.NE.IMAX.OR.JJ.NE.JMAX) THEN
	          ARRAY2(II,JJ)=0.0
	        END IF
	      END DO
	    END DO
	  END IF
	END DO
C  Do the top right corner in case it was missed
	I=NII-OBJDIAM+1
	J=NJJ-OBJDIAM+1
	ARRAY2MAX=0
	DO JJ=J,J+OBJDIAM-1
	  DO II=I,I+OBJDIAM-1
	    IF (ARRAY2(II,JJ).GT.ARRAY2MAX) THEN
	      ARRAY2MAX=ARRAY2(II,JJ)
	      IMAX=II
	      JMAX=JJ
	    END IF
	  END DO
	END DO
C  Set the other values equal to zero
	IF (ARRAY2MAX.NE.0) THEN
	  DO JJ=J,J+OBJDIAM-1
	    DO II=I,I+OBJDIAM-1
	      IF (II.NE.IMAX.OR.JJ.NE.JMAX) THEN
	        ARRAY2(II,JJ)=0.0
	      END IF
	    END DO
	  END DO
	END IF
C  Scan through the array and write the locations and intensities to the
C  data file.  The ID's will ordered in right ascension and declination.
 100	INCLINATION=0.0
	ECCENTRICITY=0.0
	FWHMA=0.0
	FWHMB=0.0
	DO I=1,4
	  IQ(I)=1
	END DO
	ICOUNT=0
	DO I=NII,1,-1
	  DO J=NJJ,1,-1
	    IF (ARRAY2(I,J).NE.0.0) THEN
	      ICOUNT=ICOUNT+1
	      IC=INT(LOG10(REAL(ICOUNT)))+1
	      ENCODE(6,2000,ID) ICOUNT
2000	      FORMAT(I<IC>)
	      WRITE(21,1201) ID,REAL(I+ISIZE(1)-1),
	1     REAL(J+ISIZE(3)-1),INCLINATION,ECCENTRICITY,
	1     FWHMA,FWHMB,(IQ(JJ),JJ=1,4),ARRAY2(I,J),SKY_PARAMETERS(1)
1201	      FORMAT(' ',A6,1X,F9.3,1X,F9.3,1X,F7.2,6X,F6.3,1X,F9.3,1X,
	1     F9.3,3X,4I2,5X,G16.8,1X,G16.8)
	    END IF
	  END DO
	END DO
C
	RETURN
	END
