	SUBROUTINE GET_FITS_MAP_LIMITS(LU_IN,NCOLS_MIN,NCOLS_MAX,
	1COLUMNS_DIFFER,NROWS_MIN,NROWS_MAX,ROWS_DIFFER)
C
C	This subroutine examines each map in a FITS file and determines the
C  minimum and maximum number of columns and rows for the set of maps.
C			Donald H. Gudehus, May 8, 2008
C			Version 2, Donald H. Gudehus, June 3, 2008
C			Added logicals COLUMNS_DIFFER,ROWS_DIFFER
C
	INCLUDE 'fitsfacts.for'
C
	LOGICAL COLUMNS_DIFFER,ROWS_DIFFER
C
	COLUMNS_DIFFER=.FALSE.
	ROWS_DIFFER=.FALSE.
	NCOLS_MIN=NAXIS1(1,LU_IN)
	NCOLS_MAX=NCOLS_MIN
	NROWS_MIN=NAXIS2(1,LU_IN)
	NROWS_MAX=NROWS_MIN
	IF (NUMMAPS(LU_IN).GT.1) THEN
	  DO I=2,NUMMAPS(LU_IN)
	    IF (NAXIS1(I,LU_IN).LT.NCOLS_MIN) THEN
	      NCOLS_MIN=NAXIS1(I,LU_IN)
	      COLUMNS_DIFFER=.TRUE.
	    END IF
	    IF (NAXIS1(I,LU_IN).GT.NCOLS_MAX) THEN
	      NCOLS_MAX=NAXIS1(I,LU_IN)
	      COLUMNS_DIFFER=.TRUE.
	    END IF
	    IF (NAXIS2(I,LU_IN).LT.NROWS_MIN) THEN
	      NROWS_MIN=NAXIS2(I,LU_IN)
	      ROWS_DIFFER=.TRUE.
	    END IF
	    IF (NAXIS2(I,LU_IN).GT.NROWS_MAX) THEN
	      NROWS_MAX=NAXIS2(I,LU_IN)
	      ROWS_DIFFER=.TRUE.
	    END IF
	  END DO
	END IF
	RETURN
	END
