	SUBROUTINE SAO_TV
C
C       This subroutine calls the various subroutines dealing with the
C  SAOimage picture display system.  Pictures in the SAD format can
C  be displayed (one or more at a time), and overlays written and erased.  
C  The object code for this module belongs in the PAN library.
C			Donald H. Gudehus, August, 1993
C			Version 1U, Donald H. Gudehus, January 29, 2008
C			Modified code for Unix and FITS
C
	INCLUDE 'saofacts.for'
C
	CHARACTER*1 COMMAND
C
	LOGICAL NEW,FILEWASOPENED
C
	CHARACTER*80 DNAME
	COMMON /DFILE/ DNAME
C
	LU_IN=11
	NEW=.FALSE.
	CALL USRINP(NEW,1,'L',4,1,'NEW=','Is this a new initialization for'//
	1' SAOimage?  (default = N)')
	IF (NEW) THEN
	  IFB_SAO=0 !  Allows the user to be prompted for the buffer size
	  CALL SAOSTART
	  CALL SAOFIRST
	END IF
C
	FILEWASOPENED=.FALSE.
  50	CONTINUE
	COMMAND='I'
	CALL USRINP(%REF(COMMAND),1,'A',1,1,'COMMAND=',
	1'Enter a command:  (default = I;  help = H)')
C
	IF (COMMAND.EQ.'A') THEN
C  Add an image to the SAOimage frame buffer
	  IF (FILEWASOPENED) CALL CLOSEFITS(LU_IN)
	  NPIC_SAO=NPIC_SAO+1
	  MODE=1
	  CALL SAODELS(-LU_IN,0,MODE)
	  CALL CLOSEFITS(LU_IN)
	  FILEWASOPENED=.FALSE.
	ELSE IF (COMMAND.EQ.'D') THEN
	  IFB_SAO=0
	  CALL SI_CLOSE_NAMEDPIPE()
	  GO TO 999
	ELSE IF (COMMAND.EQ.'E') THEN
C  Erase the SAOimage display
	  CALL SAOERAS
	ELSE IF (COMMAND.EQ.'H') THEN
C  Help by printing out list of possible commands
	  WRITE (6,2000)
	  WRITE (7,2000)
2000	FORMAT(' Enter one of the following:'
	1  / 5X, 'A = Adds an image to the SAOimage frame buffer'
	1  / 5X, 'D = Quits the TV option and deassigns SAOimage'
	1  / 5X, 'E = Erases all SAOimage frames'
	1  / 5X, 'H = Helps the user by displaying a list of commands'
	1  / 5X, 'I = Loads an image from a FITS file'
	1  / 5X, 'O = Turns off the SAOimage overlay cursors'
	1  / 5X, 'R = Turns off the SAOimage region overlay cursors'
	1  / 5X, 'Q = Quits the TV option;  SAOimage not deassigned'
	1  )
	ELSE IF (COMMAND.EQ.'I') THEN
C  Load an image from a FITS file but don't close the file in case you
C  want to try again
	  NPIC_SAO=1 !  Local initialzation
	  MODE=0 !  Entire frame buffer
	  CALL SAOERAS
	  IF (FILEWASOPENED) THEN
	    CALL SAODELS(LU_IN,0,MODE) !  File will not be opened by SAODELS
	  ELSE
	    CALL SAODELS(-LU_IN,0,MODE)
	    FILEWASOPENED=.TRUE.
	  END IF
	  CALL WRITE_SAOFACTS(7)
	ELSE IF (COMMAND.EQ.'O') THEN
C  Turn off the SAOimage overlays
	  CALL SAO_ERASE_CURSOR(0)
	ELSE IF (COMMAND.EQ.'Q') THEN
C  Quit
	  GO TO 999
	ELSE IF (COMMAND.EQ.'R') THEN
C  Turn off the SAOimage region overlays
	  CALL SAO_ERASE_CURSOR(1)
	END IF
	GO TO 50
C
 999	IF (FILEWASOPENED) CALL CLOSEFITS(LU_IN)
	RETURN
	END
