	SUBROUTINE SCALPOL(X,Y,N,KX,KY,AA,IDEGREE,FIRST)
C
C       This subroutine scales, if necessary, to the nearest power of 10
C  the values in X and Y and the coefficients for high order
C  polynomial fits to avoid underflow and overflow.  The X and Y values
C  only are scaled if FIRST (before fit).  The X, Y, and AA values are
C  scaled if .NOT.FIRST (after fit).
C
C	THUS:
C
C	CALL SCALPOL(X,Y,N,KX,KY,AA,IDEGREE,.TRUE.)
C	CALL SUESQ(NORD,X,Y,N,AA,TRX,999)
C	CALL SCALPOL(X,Y,N,KX,KY,AA,IDEGREE,.FALSE.)
C
C
	REAL*8 X(1),Y(1),AA(1),XMAX,XMIN,XAV,YMAX,YMIN,YAV,
	1SCALX,SCALY
	LOGICAL FIRST
C
	IF (FIRST) THEN
	  CALL DMNMXME(X,N,XMIN,XMAX,IMIN,IMAX,XAV)
	  CALL DMNMXME(Y,N,YMIN,YMAX,IMIN,IMAX,YAV)
	  KX=0
	  IF ((XMAX-XMIN).NE.0.0) THEN
	    KX=NINT(LOG10(XMAX-XMIN))
	  END IF
	  IF (KX.EQ.1.OR.KX.EQ.-1) KX=0
	  KY=0
	  IF ((YMAX-YMIN).NE.0.0) THEN
	    KY=NINT(LOG10(YMAX-YMIN))
	  END IF
	  IF (KY.EQ.1.OR.KY.EQ.-1) KY=0
	  IF (KX.NE.0) THEN
	    SCALX=10.0D0**KX
	    DO I=1,N
	      X(I)=X(I)/SCALX
	    END DO
	  END IF
	  IF (KY.NE.0) THEN
	    SCALY=10.0D0**KY
	    DO I=1,N
	      Y(I)=Y(I)/SCALY
	    END DO
	  END IF
	  IF (KX.NE.0.OR.KY.NE.0) THEN
	    SCALY=10.0D0**KY
	    SCALX=10.0D0**KX
	    DO I=1,IDEGREE+1
	      AA(I)=AA(I)/SCALY  ! Covers the case of certain
				 ! coefficients being held constant
	      SCALY=SCALY/SCALX
	    END DO
	  END IF
	ELSE
	  IF (KX.NE.0) THEN
	    SCALX=10.0D0**KX
	    DO I=1,N
	      X(I)=X(I)*SCALX
	    END DO
	  END IF
	  IF (KY.NE.0) THEN
	    SCALY=10.0D0**KY
	    DO I=1,N
	      Y(I)=Y(I)*SCALY
	    END DO
	  END IF
	  IF (KX.NE.0.OR.KY.NE.0) THEN
	    SCALY=10.0D0**KY
	    SCALX=10.0D0**KX
	    DO I=1,IDEGREE+1
	      AA(I)=AA(I)*SCALY
	      SCALY=SCALY/SCALX
	    END DO
	  END IF
	END IF
C
	RETURN
	END
