	SUBROUTINE STARLIST(LU_IN,ARRAY,XOFFSET,YOFFSET,SCOLUMN,SROW,SCX,SCY,
	1IQ)
C
C       This subroutine called by ACTPLT.FOR makes a list of postions
C  with the graphics terminal crosshair.
C			Rewritten by Donald H. Gudehus, October, 1982
C			Version 1U, Donald H. Gudehus, Feb. 1, 2008
C			Converted to Unix and FITS
C
C	ARRAY	(C)	An array used in FWHM
C	XOFFSET	(C)	The offset of the left side of the plot from
C			the left side of the graphics terminal measured
C			in inches
C	YOFFSET	(C)	The offset of the bottom of the plot from the
C			bottom of the graphics terminal measured in
C			inches
C	SCOLUMN	(C)	The starting column of the area of interest not
C			corrected for reading from the map
C	SROW	(C)	The starting row of the area of interest not
C			corrected for reading from the map
C	SCX	(C)	The scale in the x direction measured in
C			inches/pixel
C	SCY	(C)	The scale in the y direction measured in
C			inches/pixel
C
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*73 STRING
	DIMENSION ARRAY(1),IQ(4)
	INTEGER*4 STATUS,COLUMN,ROW,REPEAT,ADDRESS,LENGTH
	LOGICAL OFIL,STORE,PLOTDEVQUES
C
	CHARACTER*6 ID
	COMMON /ID/ ID
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	IF (PLOTDEVQUES('GD*',1)) CALL MESSAGE('Centroid an object')
C  If a graphics terminal having a separate TEK window exists, don't erase
C  the screen;  otherwise erase in order to display the prompts. 
	IF (PLOTDEVQUES('2WT',1)) THEN
	  CALL TEK(0,0,4)
	  CALL MESSAGE('Centroid an object')
	ELSE IF (PLOTDEVQUES('1WT',1)) THEN
C  Say as little as possible if only one window
	  CALL TEKPAU(0.0,0.0,1)
	END IF
C
	YCROSS=4.50
	XCROSS=0.5
	LRECTANG=20
	CALL USRINP(LRECTANG,1,'I',4,1,'LENGTH=',
	1'Enter the length of the search rectangle:  (default = 20)')
	IF (.NOT.PLOTDEVQUES('GD*',1)) THEN
	  IF (PLOTDEVQUES('2WT',1)) CALL TRANSPARENT_TO_TEK
	  IF (PLOTDEVQUES('1WT',1)) CALL TEKCON
	END IF
  5	CONTINUE
	CALL WHERE(XP,YP,ICHR)
C
	XP=XP-XOFFSET
	YP=YP-YOFFSET
	COLUMN=XP/SCX+SCOLUMN
	ROW=YP/SCY+SROW
	NI=NAXIS1(IMNUM,LU_IN)
	NJ=NAXIS2(IMNUM,LU_IN)
	LLO=COLUMN-LRECTANG/2
	MLO=ROW-LRECTANG/2
	LHI=LLO+LRECTANG
	MHI=MLO+LRECTANG
	IF (LLO.LT.1) LLO=1
	IF (MLO.LT.1) MLO=1
	IF (LHI.GT.NI) LHI=NI
	IF (MHI.GT.NJ) MHI=NJ
	NCOL=LHI-LLO+1
	NROW=MHI-MLO+1
C
C  Get inclination and eccentricity
	IF (PLOTDEVQUES('2WT',1)) THEN
	  CALL TEK(0,0,4)
	ELSE IF (PLOTDEVQUES('1WT',1)) THEN
	  CALL TEKPAU(0.0,0.0,1)
	END IF
	THETA=0.0
	CALL USRINP(THETA,1,'F',4,1,'THETA=',
	1'Enter position angle:  (default = 0)')
	LENGTH=NCOL*NROW
	CALL DYNAMIC(ADDRESS,LENGTH,'  R4',.TRUE.)
	CALL CENTR1(LU_IN,%VAL(ADDRESS),NCOL,NROW,ARRAY,1,LLO,MLO,THETA,X,Y,
	1FWHMA,FWHMB,ITOT,PEAK,SKY)
	CALL DYNAMIC(ADRESS,LENGTH,'  R4',.FALSE.)
	RATIO=FWHMB/FWHMA
	IF (RATIO.GT.1) RATIO=1.0/RATIO
	ECCENTR=SQRT(1-RATIO**2)
C	
C  Find the peak by finding the centroid in a and b and then get the
C  FWHM
C
	WRITE(6,997) X,Y
	WRITE(6,998) FWHMA,FWHMB
	WRITE(6,999) THETA,ECCENTR
	WRITE(7,997) X,Y
	WRITE(7,998) FWHMA,FWHMB
	WRITE(7,999) THETA,ECCENTR
993	FORMAT(' CENTROID =',F9.3,' ',F9.3)
994	FORMAT(' FWHM IN A =',F9.3,' ','FWHM IN B =',F9.3)
995	FORMAT(' INCLINATION =',F7.2,' ','ECCENTRICITY =',F6.3)
996	FORMAT(1X,A)
997	FORMAT(' Centroid =',F9.3,' ',F9.3)
998	FORMAT(' FWHM in a =',F9.3,' ','FWHM in b =',F9.3)
999	FORMAT(' Inclination =',F7.2,' ','Eccentricity =',F6.3)
C
C  Prepare the output file (to be used in BBEN and/or ANNULUS)
C
	STORE=.TRUE.
	CALL USRINP(STORE,1,'L',1,1,'STORE=',
	1'Do you wish to store the results?  (default = Y)')
	IF (.NOT.STORE) GO TO 50
	IF (NOBJECTS.EQ.0) THEN
	  OFIL=.FALSE.
	  CALL USRINP(OFIL,1,'L',1,1,'OLD=',
	1 'Add them to an existing file?  (default = N)')
	  IF (OFIL) THEN
	    IOCHFL=1 !  Old file
	  ELSE
	    IOCHFL=2 !  New file
	  END IF
	  CALL OPENCF(21,IOCHFL,'FILE21=',0)   
	  IF(.NOT.OFIL)WRITE(21,1200) 
1200	  FORMAT(' ','ID',8X,'COLUMN',5X,'ROW',2X,'INCLINATION',
	1 1X,'ECCENTRICITY',1X,'FWHMA',5X,'FWHMB',1X,
	1 'QUADRANT CODE        PEAK             SKY')
	END IF
	CALL USRINP(%REF(ID),1,'A',6,0,'ID=','Enter the object''s '//
	1'ID:')
	NOBJECTS=NOBJECTS+1
	CALL ALPHA(%REF(ID),1,6,LX,NF,NR,2)
	IQ(1) = 1
	IQ(2) = 1
	IQ(3) = 1
	IQ(4) = 1
	CALL MESSAGE('Enter code for each quadrant:')
	CALL MESSAGE('     0 = Want it excluded')
	CALL MESSAGE('     1 = Want it measured (default)')
	CALL MESSAGE('     2 = Abort this object')
	CALL USRINP(IQ,4,'I',4,1,'QUADRANTS=',' ')
	IF (IQ(1).EQ.2) GO TO 50
	WRITE(21,1201) ID,X,Y,THETA,ECCENTR,FWHMA,FWHMB,(IQ(J),J=1,4),
	1PEAK,SKY
1201	FORMAT(' ',A6,1X,F9.3,1X,F9.3,1X,F7.2,6X,F6.3,1X,F9.3,1X,
	1F9.3,3X,4I2,5X,G16.8,1X,G16.8)
C
   50 	CONTINUE
	MORE=.TRUE.
	CALL USRINP(MORE,1,'L',1,1,'MORE=','More objects to fit?  '//
	1'(default = Y)')
	IF (.NOT.PLOTDEVQUES('GD*',1)) THEN
	  IF (PLOTDEVQUES('2WT',1)) CALL TRANSPARENT_TO_TEK
	  IF (PLOTDEVQUES('1WT',1)) CALL TEKCON
	END IF
	IF (MORE) GO TO 5
C
	CLOSE (UNIT=21)
	RETURN
	END
