	SUBROUTINE MIIPSOPT
C
C       This subroutine selects the various options available under MIIPS for Unix.
C  It is fashioned after MIIPSOPT for MIIPS for OpenVMS.
C					Donald H. Gudehus, January 21, 2008
C
	BYTE BOPTION(80)
	CHARACTER OPTION*80,OPT*10
	EQUIVALENCE (BOPTION,OPTION)
        CHARACTER TIME*21
C
	LOGICAL OPTION_PARAM,PROCEED
C
	LUIN=5
C
   2	NP=1 !  Sets pointer for first option
C
C  Write the time to the terminal and the log file and prompt
C  the user.
C
        CALL DATE_TIME(TIME)
	WRITE(6,1000) TIME(14:21)
	WRITE(7,998) TIME
1000	FORMAT(/' Enter an option:',30X,A23/' OPTION=',$)
 998	FORMAT(/' Enter an option:',30X,A23)
C
C  Accept the command from the terminal.
C
   5	READ(LUIN,1001,END=2) NCHAR,OPTION
1001	FORMAT(Q,A)
	WRITE(7,1002) OPTION
1002	FORMAT(' OPTION=',A)
C  Convert to upper case
	IF (OPTION(1:1).EQ.'.') THEN
	  IF (BOPTION(2).GE.97.AND.BOPTION(2).LE.122) BOPTION(2)=BOPTION(2)-32
	  IF (BOPTION(3).GE.97.AND.BOPTION(3).LE.122) BOPTION(3)=BOPTION(3)-32
	ELSE
	  DO I=1,80
	    IF (BOPTION(I).GE.97.AND.BOPTION(I).LE.122)
	1   BOPTION(I)=BOPTION(I)-32
	  END DO
	END IF
C
C  Return point for main loop
   3	CONTINUE
	PROCEED=OPTION_PARAM(OPTION,NP,N1,N2,N3) !  N1, N2, and N3 are returned
C  N1 the position of the start of the current option.
C  N2 the position of the end of the current option.
C  N3 the position of the end of the parameter list.
C  Store any keywords and parameters in the buffer B in STRKEY if a .OPTION
C  is used.  If there are none, store parentheses instead.
	IF (.NOT.PROCEED) GO TO 2
 	CALL STRKEY(OPTION(N2:N3))
C
	IF (OPTION(N1:N1).EQ.'.') THEN !  The option is to be repeated
	  N1=N1+1
	  CALL RESTR(OPTION(N1:N2)//'.sve') !  Opens and reads the SAVE file and puts
				    !  keywords and parameters in the
				    !  the buffer B in STRKEY for use by USRINP
	END IF
C
	CALL SAVE(OPTION(N1:N2)//'.sve') !  Opens a new save file
C
C  Search for option using two letter match
C
	OPT=OPTION(N1:N1+2)
C
C
C  Specials
C
	IF (OPT(1:2).EQ.'  ') THEN
	  CONTINUE
	ELSE IF (OPT(1:2).EQ.'HE') THEN
	  CALL MIIPS_HELP(OPTION(INDEX(OPTION,' ')+1:))
C  Regulars, placed in alphabetical order of option for each category
C
C  Arithmetic for maps and rows
C
	ELSE IF (OPT(1:2).EQ.'AR') THEN
	  CALL ARITHMETIC_FITS_SIMPLE
	ELSE IF (OPT(1:2).EQ.'FS') THEN
	  CALL FLATSPEC
C
C  Calibrations - photometric, photographic, and wavelengths
C
	ELSE IF (OPT(1:2).EQ.'AV') THEN
	  CALL AVERAGE
C
C  Coordinates, Transforms, and Redshifts - X Y, RA and DEC, Fourier
C					    transforms,Redshifts 
C
	ELSE IF (OPT(1:2).EQ.'FI') THEN
	  CALL FIND
C
C  Display - Lineplots, TV, and 2D pictures
C
	ELSE IF (OPT(1:2).EQ.'AC') THEN
	  CALL ACTPLT
	ELSE IF (OPT(1:2).EQ.'DA') THEN
	  CALL DISPANN
	ELSE IF (OPT(1:2).EQ.'IP') THEN
	  CALL IMAGPROC
	ELSE IF (OPT(1:2).EQ.'PL') THEN 	  	
	  CALL LINEPL_FITS
	ELSE IF (OPT(1:2).EQ.'PT') THEN
	  CALL PRINTERM
	ELSE IF (OPT(1:2).EQ.'TV') THEN 
	  CALL TV 
C
C  Editing - Headers and Data
C
	ELSE IF (OPT(1:2).EQ.'EC') THEN
	  CALL EDITCIRCL
	ELSE IF (OPT(1:2).EQ.'EP') THEN
	  CALL EDITPOINT
	ELSE IF (OPT(1:2).EQ.'ER') THEN
	  CALL EDITRECT
	ELSE IF (OPT(1:2).EQ.'PH') THEN
	  CALL PRINTHEAD
C
C  Filters - 1D, 2D, real and in the FT plane
C

C
C  Photometry - Spectral, Stellar, and Surface
C
	ELSE IF (OPT(1:2).EQ.'EA') THEN
	  CALL ANNULUS
C
C  Topological transformations -
C  Flip, Rotate, and Move Maps, Lines, and Bits about
C
	ELSE IF (OPT(1:2).EQ.'CR') THEN
	  CALL CROP_FITS_SIMPLE
	ELSE IF (OPT(1:2).EQ.'FM') THEN
	  CALL FMAP
	ELSE IF (OPT(1:2).EQ.'RO') THEN
	  CALL ROTATE
C
C  Utilities - Statistics, Fitting routines, Faking maps, etc.
C
	ELSE IF (OPT(1:2).EQ.'FG') THEN
	  CALL FAKGAL
	ELSE IF (OPT(1:2).EQ.'FA') THEN
	  CALL FAKSTAR
	ELSE IF (OPT(1:2).EQ.'MA') THEN
	  CALL FITSMASK
	ELSE IF (OPT(1:2).EQ.'NI') THEN
	  CALL NOISE
	ELSE IF (OPT(1:3).EQ.'RG') THEN
	  CALL RADGAL
c	ELSE IF (OPT(1:3).EQ.'RGO') THEN
c	  CALL RADGALOLD
	ELSE IF (OPT(1:2).EQ.'ST') THEN
	  CALL STATS
C
	ELSE IF (OPT.EQ.'EX'.OR.OPT.EQ.'EXI'.OR.OPT.EQ.'EXIT'
	1.OR.OPT.EQ.'ex'.OR.OPT.EQ.'exi'.OR.OPT.EQ.'exit') THEN
	  STOP
	ELSE
	  CALL ERROR(-1,'Option requested does not exist')
	  CALL SAVEC('DELETE')
	  GO TO 2
	END IF
	CALL SAVEC('SAVE') !  Closes SAVE file
	NP=N3+1
	IF (NP.LT.NCHAR) GO TO 3 !  More input options present
	NP=1
	GO TO 2 !  Normal return for prompt
C
	END
