	SUBROUTINE SCAN_SIMPLE(ARRAY,NCOLS,NROWS,XYOFF,XYSCALE,THRESHOLD,
	1PENWIDTH,COLOR)
C
C       This subroutine produces a simple scan of the array ARRAY, 
C  writing a vector on the screen when a given threshold level is exceeded.
C  Various dashings, penwidths, and colors are possible.
C
C			Donald H. Gudehus, March, 1993
C			Version 2, Donald H. Gudehus, October, 1994
C			Introduced calls to PLOTDEVQUES and PLOT
C
C	ARRAY	  (C)	The two-dimensional array containing the data
C	NCOLS	  (C)	The number of columns in the array
C	NROWS	  (C)	The number of rows in the array
C	XYOFF	  (C)	The X and Y offsets for the lower left corner
C			of the plot of the plot device
C	XYSCALE	  (C)	The X and Y scale factors in units of inches
C			per array element
C	THRESHOLD (C)	The value above which a line will be drawn
C
	DIMENSION ARRAY(NCOLS,NROWS),XYOFF(2),XYSCALE(2)
	INTEGER PENWIDTH,COLOR  ! Not dimensioned since only one contour
			        ! is allowed
	LOGICAL PLOTDEVQUES
C
	CALL PENMODE(PENWIDTH)
	CALL COLORMODE(COLOR)
C  Outer loop will step through the rows
	DO IROW=1,NROWS
C  Set new y value for plotting for this row 
	  Y=(IROW-1)*XYSCALE(2)
	  CALL PLOT(0.0,Y,3) 
	  ISABOV=0
C  Now plot this row
	  DO 180 ICOL=1,NCOLS
	    VAL=ARRAY(ICOL,IROW)
	    X=(ICOL-1)*XYSCALE(1)
	    IF (VAL.GT.THRESHOLD) GO TO 80
C  Value is below threshold;  if last was above must draw in a line. 
	    IF (ISABOV.EQ.0) GO TO 180 
	    CALL PLOT(X,Y,2) 
	    ISABOV=0
	    GO TO 180 
C  Point is above threshold.  draw dark vector
C  If last was below threshold
 80	    CONTINUE
	    IF (ISABOV.EQ.1) GO TO 180 
	    CALL PLOT(X,Y,3)
	    ISABOV=1
 180	  CONTINUE
C  Plotted a row, check if light vector needs to be drawn to end of row 
	  IF (ISABOV.EQ.0) GO TO 200 
	  CALL PLOT(X,Y,2)
 200	  CONTINUE
	  IF (PLOTDEVQUES('D*',0).AND.MOD(IROW,100).EQ.0) CALL PLOT(0,0,15)
	END DO
	IF (PLOTDEVQUES('D*',0)) CALL PLOT(0,0,15)
C
	RETURN
	END
