	SUBROUTINE SCANSL(C,PENWIDTH,COLOR,IC,SCX,SCY,I0,L,JJ,IS,
	1DATL,DATU)
C
C  VOOR EEN UITGEBREIDE TOELICHTING ZIE HET PONSFORMULIER
C                       SET CONSTANTS
C
C			Version 2, Donald H. Gudehus, June, 1988
C			Added arguments PENWIDTH to control
C			penwidth, and COLOR for the color.
C			Version 3, Donald H. Gudehus, February 28, 2000
C			Fixed bug where if first row contained a value 
C			that was higher than the lowest contour level,
C			a vertical artifact the full height of the area
C			would be generated.  Fixed by reducing T1 and
C			T2 below.
C
	LOGICAL F1,F3,F5,F7
	DIMENSION C(IC),DATL(1),DATU(1)
	INTEGER COLOR(IC),PENWIDTH(IC)
C
	Y0=FLOAT(JJ)*SCY
	L1=L-1
	L2=0
	IF (IS.LT.0) L2=L
C
CCC          START POINT LOOP - CHECK FOR UNDEFINED POINTS
C
	DO 80 I=1,L1
	  II=I*IS+L2
	  X0=FLOAT(II-1)*SCX
	  T1=DATL(I0+II)
	  IF (T1.GE.C(1)) T1=C(1)*0.99
	  T2=DATL(I0+II+1)
	  IF (T2.GE.C(1)) T2=C(1)*0.99
	  T3=DATU(I0+II)
	  T4=DATU(I0+II+1)
	  N=0
	  IF (T1.EQ.-999.0) N=N+1
	  IF (T2.EQ.-999.0) N=N+1
	  IF (T3.EQ.-999.0) N=N+1
	  IF (T4.EQ.-999.0) N=N+1
	  IF (N-1) 10,40,70
  10	  T5=(T1+T2+T3+T4)*0.25
C
CCC          ALL FOUR POINTS DEFINED - DETERMINE PATHS
C
	  DO 30 K=1,IC
	    CT=C(K)
	    S1=T1-CT
	    S2=T2-CT
	    S3=T3-CT
	    S4=T4-CT
	    S5=T5-CT
	    IF (S1.EQ.0.0.AND.S2.EQ.0.0) GO TO 20
	    IF (S3.EQ.0.0.AND.S4.EQ.0.0) GO TO 30
	    F1=.FALSE.
	    F3=.FALSE.
	    F5=.FALSE.
	    F7=.FALSE.
	    IF (S1*S2.LE.0.0) F1=.TRUE.
	    IF (S2*S4.LT.0.0) F3=.TRUE.
	    IF (S3*S4.LE.0.0) F5=.TRUE.
	    IF (S1*S3.LT.0.0) F7=.TRUE.
	    IF (F1.AND.F3.AND.F5.AND.F7) GO TO 16
	    N=0
	    IF (F5.AND.F3) N=6
	    IF (F7.AND.F5) N=5
	    IF (F7.AND.F3) N=4
	    IF (F1.AND.F7) N=3
	    IF (F1.AND.F5) N=2
	    IF (F1.AND.F3) N=1
	    IF (N.EQ.0) GO TO 30
	    IF (S2*S5.GE.0.0) N=N+6
C
CCC          BRING PEN TO PATH ENTRANCE
C
	    CALL PENMODE(PENWIDTH(K))
	    CALL COLORMODE(COLOR(K))
	    GO TO (11,11,11,12,12,13,11,11,11,12,12,13),N
  11	    X=X0+S1/(S1-S2)*SCX
	    CALL PLOT(X,Y0,3)
	    GO TO (2,2,2,9,9,9,8,8,8,9,9,9),N
  12	    Y=Y0+S1/(S1-S3)*SCY
	    CALL PLOT(X0,Y,3)
	    GO TO (9,9,9,8,8,9,9,9,9,6,6,9),N
  13	    X=X0+S3/(S3-S4)*SCX
	    CALL PLOT(X,Y0+SCY,3)
	    GO TO (9,9,9,9,9,6,9,9,9,9,9,4),N
C
CCC          FOLLOW PATHS
C
   2	    X=X0+(S5/(S5-S2)*0.5+0.5)*SCX
	    Y=Y0+S2/(S2-S5)*0.5*SCY
	    CALL PLOT(X,Y,2)
	    GO TO (3,4,4,3,4,3,9,9,9,9,9,9),N
   3	    Y=Y0+S2/(S2-S4)*SCY
	    CALL PLOT(X0+SCX,Y,2)
	    GO TO 9
   4	    X=X0+(S5/(S5-S4)*0.5+0.5)*SCX
	    Y=Y0+(S5/(S5-S4)*0.5+0.5)*SCY
	    CALL PLOT(X,Y,2)
	    GO TO (9,5,6,9,5,9,3,9,9,3,9,3),N
   5	    X=X0+S3/(S3-S4)*SCX
	    CALL PLOT(X,Y0+SCY,2)
	    GO TO 9
   6	    X=X0+S3/(S3-S5)*0.5*SCX
	    Y=Y0+(S5/(S5-S3)*0.5+0.5)*SCY
	    CALL PLOT(X,Y,2)
	    GO TO (9,9,7,9,9,8,4,5,9,4,5,9),N
   7	    Y=Y0+S1/(S1-S3)*SCY
	    CALL PLOT(X0,Y,2)
	    GO TO 9
   8	    X=X0+S1/(S1-S5)*0.5*SCX
	    Y=Y0+S1/(S1-S5)*0.5*SCY
	    CALL PLOT(X,Y,2)
	    GO TO (9,9,9,2,2,2,6,6,7,9,9,9),N
   9	    CONTINUE
	    GO TO (14,30,30,30,30,30,30,30,15,30,30,30),N
C
CCC          TWO-WAY TRAFFIC
C
  16	    N=1
	    IF (S1*S4.LE.S2*S3) N=9
	    GO TO 11
  14	    IF (.NOT.(F7.AND.F5)) GO TO 30
	    N=11
	    GO TO 12
  15	    IF (.NOT.(F5.AND.F3)) GO TO 30
	    N=12
	    GO TO 13
C
CCC          POINTS 1 & 2 EQ CONTOUR LEVEL - END LOOP
C
  20	    CALL PLOT(X0,Y0,3)
	    CALL PLOT(X0+SCX,Y0,2)
  30	  CONTINUE
	  GO TO 70
C
C            ONE UNDEFINED POINT - FIND POSSIBLE ENTRANCES
C
  40	  CONTINUE
	  DO 60 K=1,IC
	    CT=C(K)
	    S1=T1-CT
	    S2=T2-CT
	    S3=T3-CT
	    S4=T4-CT
	    IF (S1.EQ.0.0.AND.S2.EQ.0.0) GO TO 50
	    IF (S2.EQ.0.0.AND.S4.EQ.0.0) GO TO 60
	    IF (S3.EQ.0.0.AND.S4.EQ.0.0) GO TO 60
	    IF (S3.EQ.0.0.AND.S1.EQ.0.0) GO TO 55
	    F1=.FALSE.
	    F3=.FALSE.
	    F5=.FALSE.
	    F7=.FALSE.
	    IF (S1*S2.LE.0.0) F1=.TRUE.
	    IF (S4*S2.LE.0.0) F3=.TRUE.
	    IF (S4*S3.LE.0.0) F5=.TRUE.
	    IF (S1*S3.LE.0.0) F7=.TRUE.
C
CCC          DETERMINE UNDEFINED POINT AND PATH
C
	    IF (T2.EQ.-999.0) GO TO 42
	    IF (T3.EQ.-999.0) GO TO 43
	    IF (T4.EQ.-999.0) GO TO 44
	    N=4
	    IF (F3) N=1
	    IF (F5) GO TO 452
	    N=4
	    IF (F3) GO TO 453
	    GO TO 60
  42	    N=3
	    IF (F7) N=2
	    IF (F5) GO TO 452
	    N=3
	    IF (F7) GO TO 454
	    GO TO 60
  43	    N=3
	    IF (F3) N=1
	    IF (F1) GO TO 451
	    N=3
	    IF (F3) GO TO 453
	    GO TO 60
  44	    N=4
	    IF (F7) N=2
	    IF (F1) GO TO 451
	    N=4
	    IF (F7) GO TO 454
	    GO TO 60
C
CCC      BRING PEN TO ENTRANCE
C
 451	    X=X0+S1/(S1-S2)*SCX
	    CALL PLOT(X,Y0,3)
	    GO TO (461,462,463,464),N
 452	    X=X0+S3/(S3-S4)*SCX
	    CALL PLOT(X,Y0+SCY,3)
	    GO TO (461,462,463,464),N
 453	    Y=Y0+S2/(S2-S4)*SCY
	    CALL PLOT(X0+SCX,Y,3)
	    GO TO (50,462,463,464),N
 454	    Y=Y0+S1/(S1-S3)*SCY
	    CALL PLOT(X0,Y,3)
	    GO TO (461,50,463,464),N
C
CCC          FOLLOW PATH
C
 461	    Y=Y0+S2/(S2-S4)*SCY
	    CALL PLOT(X0+SCX,Y,2)
	    GO TO 60
 462	    Y=Y0+S1/(S1-S3)*SCY
	    CALL PLOT(X0,Y,2)
	    GO TO 60
 463	    X=X0+S1/(S1-S4)*SCX
	    Y=Y0+S1/(S1-S4)*SCY
	    CALL PLOT(X,Y,2)
	    GO TO 60
 464	    X=X0+S3/(S3-S2)*SCX
	    Y=Y0+S2/(S2-S3)*SCY
	    CALL PLOT(X,Y,2)
	    GO TO 60
C
CCC          TWO POINTS EQUAL CONTOUR LEVEL
  50	    CALL PLOT(X0+SCX,Y0,3)
	    CALL PLOT(X0,Y0,2)
	    IF (S3.EQ.0.0) CALL PLOT(X0,Y0+SCY,2)
	    GO TO 60
  55	    CALL PLOT (X0,Y0,3)
	    CALL PLOT(X0,Y0+SCY,2)
C
CCC          ENDS OF LOOPS - EXIT
  60	  CONTINUE
  70	  CONTINUE
  80	CONTINUE
	IS=-IS
	RETURN
	END
