	SUBROUTINE STATS
C
C       This subroutine computes the mean, mean error, mean error of the
C  mean error, mean square, minimum, maximum, and their locations  from a
C  rectangular area of a map.  The coordinates can be input manually or by
C  the SAOiamge cursor-box.  A plot of the distribution or of the residuals,
C  along with a computed gaussian having the same sigma and the same scaling
C  in the Y direction is then made.  
C       This version was rewritten from  GAUSTA and MNMX of the OpenVMS version
C  of MIIPS.
C			Donald H. Gudehus, January 23, 2008
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*1 AS(101),STAR,ALET,BLANK,ARRO,AX
	CHARACTER*2 COMMAND
	CHARACTER*3 PRGFMAT
	CHARACTER*40 FILEKEYWORD
	CHARACTER*50 XLABEL,YLABEL,TITLE
	CHARACTER*80 FILENAME
C
	INTEGER*2 IX(5),IY(5)
	INTEGER*2 IX1,IY1,IX2,IY2
	INTEGER PLANEKEY,STATUS
	INTEGER ISIZE(4),IBIN(34),COLOR(2)
	INTEGER NPOINTS(2),LINVECT(2),INC(2),LINTYPE(2),NSYMBOL(2),ADDRESS,
	1ADDRESS2
C
	LOGICAL ENTRY_TV,FIRSTIME,IOFL,EXCLUDE,PLOTIT,MORE,INVERT(2),INTERACT,
	1CROSSHAIRS,MOSTPROBABLE
C
	REAL*4 DAT(MAXSIZE),GAU(34),XARRAY(50,2),YARRAY(50,2)
	REAL*4 NUMBERPIX,MEANERROR,MEANERMEAN,MEANERMER,MINMAX(2)
C
	REAL*8 SUMR,SUMRSQ,SUMSQDEV,FMEAN,MEANSQUARE,PROBABLE_VAL,SIGMA
C
	COMMON /CHAR_SCRATCH_BLOCK/ COMMAND,XLABEL,YLABEL,
	1TITLE
C
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY_AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
C  The above logicals are set by a previous call to GET_DP_AVAILABILITY
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	DATA STAR,ALET,BLANK,ARRO,AX /'*','I',' ','(','X'/
C
	CALL MESSAGE('STATS, Version 1')
	ENTRY_TV=.FALSE.
	LU_IN=11
	FILEKEYWORD='FILE='
	FILENAME=' '
	IOFL=.TRUE.
	MAPKEY=0
	PLANEKEY=0
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	COMMAND=' '
	DO WHILE (COMMAND.NE.'AS'.AND.COMMAND.NE.'S'.AND.COMMAND.NE.'M')
	  CALL MESSAGE('Enter a command:')
	  COMMAND='M'
	  IF (SAOIMAGE) THEN
	    CALL MESSAGE('     AS = Boundaries from cursor box;  SAOimage '//
	1   'already loaded')
	    CALL MESSAGE('      S = Boundaries from cursor box;  need to '//
	1   'load SAOimage')
	  END IF
	  CALL MESSAGE('      M = Manual input of boundaries (default)')
	  CALL USRINP(%REF(COMMAND),1,'A',2,1,'COMMAND=',' ')
	  CALL ALPHA(%REF(COMMAND),1,2,NC,NF,NR,2)
	END DO
C
	IF (COMMAND.EQ.'S') THEN
	  NPIC_SAO=1
	  IF (IFB_SAO.EQ.0) THEN
	    CALL SAOSTART
	    CALL SAOFIRST
	  ELSE
	    CALL SAOERAS
	  END IF
	  CALL SAODELS(LU_IN,1,0)
	END IF
  50	IF (COMMAND.EQ.'M') THEN
	  ISIZE(1)=1
	  ISIZE(2)=NAXIS1(IMNUM,LU_IN)
	  ISIZE(3)=1
	  ISIZE(4)=NAXIS2(IMNUM,LU_IN)
	  CALL USRINP(ISIZE,4,'I',4,1,'BOUNDARIES=',
	1 'Enter start-column end-column start-row end-row:  '//
	2 '(default = entire map)')
	  ILO=ISIZE(1)
	  IHI=ISIZE(2)
	  JLO=ISIZE(3)
	  JHI=ISIZE(4)
	  GO TO 100
	END IF
C  Direct the flow past the entry point
	IF (COMMAND.EQ.'S'.OR.COMMAND.EQ.'AS') GO TO 70
C
	ENTRY TV_STATS_SAO
C
	ENTRY_TV=.TRUE.
	FIRSTIME=.TRUE.
	IF (SAOIMAGE) THEN
  70	  COMMAND='AS'
C  Read cursor coordinates.  The map coordinates are calculated on the
C  assumption that the map size was not scaled up or down when it was
C  loaded.  The file does not need to be open for reading the cursor
C  coordinates.
	  MODE=2 !  Allows updating of DNAME if cursor is placed in a new
		 !  image
	  CALL SAO2CUR(MODE,IX1,IY1,IX2,IY2,X1,Y1,X2,Y2,XM1,YM1,XM2,YM2,
	1 NPIC1,KEY,X,Y,a,b)
	  IF (ENTRY_TV.AND.FIRSTIME) THEN
	    CALL GET_LU_FROM_SAO(LU_IN,NPIC1,STATUS)
	    IF (STATUS.NE.0) RETURN
	    FIRSTIME=.FALSE.
	  END IF
	END IF
C
	XPOS2=AMAX1(XM1,XM2)
	IF (XM2.EQ.XPOS2) THEN
	  XPOS1=XM1
	ELSE
	  XPOS1=XM2
	END IF
	YPOS2=AMAX1(YM1,YM2) 
	IF (YM2.EQ.YPOS2) THEN
	  YPOS1=YM1
	ELSE
	  YPOS1=YM2
	END IF
	ILO=XPOS1
	IHI=XPOS2
	JLO=YPOS1
	JHI=YPOS2
 100	CONTINUE
	GAU(1)=.00008
	GAU(2)=.0002
	GAU(3)=.0004
	GAU(4)=.001
	GAU(5)=.003
	GAU(6)=.006
	GAU(7)=.012
	GAU(8)=.024
	GAU(9)=.045
	GAU(10)=.080
	GAU(11)=.134
	GAU(12)=.211
	GAU(13)=.317
	GAU(14)=.453
	GAU(15)=.617
	GAU(16)=.803
	GAU(17)=1.000
	EXCLUDE=.FALSE.
	CALL USRINP(EXCLUDE,1,'L',1,1,'EXCLUDE=',
	1'Do you wish to exclude edited areas (zero value):  (default = N)')
C
C  Distribution of residuals
C
	WRITE(7,2050) ILO,IHI,JLO,JHI
2050	FORMAT(' ','STATISTICS FOR THE REGION'/' Start-column =',
	1I5,'  End-column = ',I5,'  Start-row = ',I5,'  End-row = ',
	1I5,///)
C  Get set up for calculating the minimum and maximum and their locations
	RMX=-1.0E+37
	RMN=1.0E+37
C
	DO III=1,17
	  JJ=18-III
	  GAU(III+17)=GAU(JJ)
	END DO
	SUMR=0.0D0
	SUMRSQ=0.0D0
	NUMBERPIX=0.0
	DO J=JLO,JHI
	  CALL RDFITSROW(LU_IN,IMNUM,IPNUM,DAT,NCOLS,J)
	  DO I=ILO,IHI
	    IF ((EXCLUDE.AND.DAT(I).NE.0.0).OR..NOT.EXCLUDE) THEN
	      IF (DAT(I).GT.RMX) THEN
	        RMX=DAT(I)
	        MXCOL=I
	        MXROW=J
	      END IF
	      IF (DAT(I).LT.RMN) THEN
	        RMN=DAT(I)
	        MNCOL=I
	        MNROW=J
	      END IF
	      SUMR=SUMR+DAT(I)
	      SUMRSQ=SUMRSQ+DAT(I)*DAT(I)
	      NUMBERPIX=NUMBERPIX+1
	    END IF
	  END DO
	END DO
	FMEAN=SUMR/NUMBERPIX
C  Calculate the preliminary mean error 
	MEANERROR=SQRT(ABS((SUMRSQ-SUMR*SUMR/NUMBERPIX)/(NUMBERPIX-1.0)))
	DO I=1,34
	  IBIN(I)=0
	END DO
	SUMSQDEV=0.0
	MEANSQUARE=0.0
	DO J=JLO,JHI
	  CALL RDFITSROW(LU_IN,IMNUM,IPNUM,DAT,NCOLS,J)
	  DO I=ILO,IHI
	    IF ((EXCLUDE.AND.DAT(I).NE.0.0).OR..NOT.EXCLUDE) THEN
	      SUMSQDEV=SUMSQDEV+(DAT(I)-FMEAN)**2
	      MEANSQUARE=MEANSQUARE+DAT(I)**2
C  Compute the vertical, i.e. abscissa, distance for the logfile;  measures
C  distance from the mean in units of 0.25 sigma.
	      NBIN=NINT(4.0*(DAT(I)-FMEAN)/AMAX1(1.0E-14,MEANERROR)+17.5)
C  Compute the total number of pixels with values beyond the value along 
C  the abscissa.  This is NOT the true distribution.
	      IF (NBIN.LT.1) NBIN=1
	      IF (NBIN.GT.34) NBIN=34
	      IF (NBIN.LE.17) GO TO 340
	      DO K=18,NBIN
	        IBIN(K)=IBIN(K)+1
	      END DO
	      GO TO 348
 340	      DO K=NBIN,17
	        IBIN(K)=IBIN(K)+1
	      END DO
 348	      CONTINUE
	    END IF
 	  END DO
	END DO
	MEANERROR=SQRT(SUMSQDEV/(NUMBERPIX-1.0))
	MEANERMEAN=MEANERROR/SQRT(NUMBERPIX)
	MEANERMER=MEANERROR/SQRT(2*(NUMBERPIX-1.0))
	MEANSQUARE=MEANSQUARE/NUMBERPIX
	WRITE (6,2055) RMX,MXCOL,MXROW
	WRITE (6,2056) RMN,MNCOL,MNROW
2055	FORMAT(' Maximum =',G14.7,'at X =',I5,'  Y =',I5)
2056	FORMAT(' Minimum =',G14.7,'at X =',I5,'  Y =',I5)
	WRITE (7,2055) RMX,MXCOL,MXROW
	WRITE (7,2056) RMN,MNCOL,MNROW
	WRITE(6,2061) FMEAN,MEANERROR,MEANERMEAN,MEANERMER,MEANSQUARE,
	1INT(NUMBERPIX)
2061	FORMAT(' The mean is ',G14.7/' The mean error per pixel is ',G14.7/
	1' The mean error of the mean is ',G13.6/
	2' The mean error of the mean error per pixel is ',G13.6/
	3' The mean square is ',G13.6/
	4' The number of points is ',I10)
	WRITE(7,2061) FMEAN,MEANERROR,MEANERMEAN,MEANERMER,MEANSQUARE,
	1INT(NUMBERPIX)
	MOSTPROBABLE=.TRUE.
	CALL USRINP(MOSTPROBABLE,1,'L',1,1,'MOST_PROBABLE=',
	1'Do you want to calculate the most probable value:  (default = Y)')
	IF (MOSTPROBABLE) THEN
	  LENGTH=(IHI-ILO+1)*(JHI-JLO+1)
	  NBINS=1000
	  CALL DYNAMIC(ADDRESS,LENGTH,'  R4',.TRUE.)
	  CALL DYNAMIC(ADDRESS2,NBINS,'  I4',.TRUE.)
	  CALL PROBABLE2DS(LU_IN,%VAL(ADDRESS),IHI-ILO+1,JHI-JLO+1,ILO,
	1 JLO,%VAL(ADDRESS2),NBINS,EXCLUDE,PROBABLE_VAL,SIGMA)
	  CALL DYNAMIC(ADDRESS,LENGTH,'  R4',.FALSE.)
	  CALL DYNAMIC(ADDRESS2,NBINS,'  I4',.FALSE.)
	  WRITE(6,2065) PROBABLE_VAL,SIGMA
2065	  FORMAT(' ','The most probable value is ',G13.6/
	1 ' The sigma is ',G13.6)
	  WRITE(7,2065) PROBABLE_VAL,SIGMA
	END IF

	WRITE(7,2070)
2070	FORMAT(' '///15X,'X = GAUSSIAN'/15X,'* = OBSERVED POINTS'/' ',
	1'DEVIATION'/
	211X,'0        10        20        30        40        50',
	3'        60        ',
	4'70        80        90       100',4X,'EXPECTED',2X,
	5'ACTUAL')
C
C  Initialize the plotting arrays
	DO I=1,50
	  XARRAY(I,1)=0.0
	  YARRAY(I,1)=0.0
	END DO
C  Horizontal distance in log gives twice the probability of
C  a point being found from minus infinity to the deviation indicated
C  on the given side of the mean.
	DO 380 I=1,34
	  DO K=1,101 !  Loop for putting I's in log file plot.  Range
		     !  from 0 to 100 gives 101 ordinate locations.  Index
		     !  starts at 1 for convenience.
	    AS(K)=BLANK
	    IF (K.EQ.1.OR.K.EQ.26.OR.K.EQ.51.OR.K.EQ.76.OR.K.EQ.101)
	1   AS(K)=ALET
	  END DO
	  MGAU=GAU(I)*100. + 1. !  Ordinate distance in log file
			 	!  for "X" symbols which represent points for
			 	!  the gaussian.
	  AS(MGAU)=AX
	  DEVIATION=FLOAT(I-17)/4.0
C  In the log file, the units on the abscissa axis lie on the same row as the
C  histogram points hence 0.00 on the abscissa axis is repeated.
	  IF (I.GE.18) DEVIATION=DEVIATION-0.25 !  On the graphics plot
						!  we don't have the
						!  above restriction.
	  IF (I.LT.18) THEN
	    XARRAY(I,1)=DEVIATION-0.125
	    XARRAY(I,2)=DEVIATION-0.125
	  ELSE IF (I.GE.18) THEN
	    XARRAY(I,1)=DEVIATION+0.125
	    XARRAY(I,2)=DEVIATION+0.125
	  END IF
	  YARRAY(I,1)=FLOAT(IBIN(I)) !  The observed number in each
				     !  interval
	  PCT=200.*FLOAT(IBIN(I))/NUMBERPIX !  Horizontal distance for
					    !  observed number on print-
					    !  ed output.
	  MSTAT=PCT+1.0 !  Range is now 1 to some maximum
	  EXPECT=NUMBERPIX*GAU(I)*.5
	  YARRAY(I,2)=EXPECT
	  IF (MSTAT.GT.101) MSTAT=101 !  Range is now 1 to 101
	  AS(MSTAT)=STAR
	  WRITE(7,2080) DEVIATION,AS,EXPECT,IBIN(I)
2080	  FORMAT(F7.2,4X,101A1,F11.3,I9)
 380	CONTINUE
	PLOTIT=.TRUE.
	CALL USRINP(PLOTIT,1,'L',1,1,'PLOT=','Do you wish to have '// 
	1'the residuals plotted?  (default = Y)')
	NPOINTS(1)=34
	NPOINTS(2)=34
	LINVECT(1)=0
	LINVECT(2)=1
	INC(1)=1
	INC(2)=1
	LINTYPE(1)=998
	LINTYPE(2)=0
	NSYMBOL(1)=3
	NSYMBOL(2)=0
	INVERT(1)=.FALSE.
	INVERT(2)=.FALSE.
	COLOR(1)=16776960
	COLOR(2)=16711935
	INTERACT=.FALSE.
	CROSSHAIRS=.TRUE.
	IF (PLOTIT) THEN
	  XLABEL='STANDARD DEVIATIONS'
	  YLABEL='TOTAL NUMBER BEYOND ABSCISSA VALUE'
	  TITLE='GAUSSIAN STATISTICS'
	  CALL XYPLOT(XARRAY,YARRAY,50,2,NPOINTS,LINVECT,INC,LINTYPE,
	1 NSYMBOL,INVERT,COLOR,INTERACT,CROSSHAIRS,XLABEL,YLABEL,
	2 TITLE,' ',.FALSE.)
	  CALL RESETTEK
	END IF
C
	PLOTIT=.TRUE.
	CALL USRINP(PLOTIT,1,'L',1,1,'PLOT=','Do you wish to plot'//
	1' the true distribution of pixel values?  (default = Y)')
	IF (PLOTIT) THEN
	  CALL USRINP(MINMAX,2,'F',4,0,'MIN_MAX=',
	1 'Enter the minimum and maximum pixel values for the distribution:')
C  Initialize the plotting arrays
	  DO I=1,50
	    XARRAY(I,1)=0.0
	    YARRAY(I,1)=0.0
	  END DO
C  Assume 33 bars
	  DELTA=(MINMAX(2)-MINMAX(1))/32.0
	  DO I=1,33
	    XARRAY(I,1)=MINMAX(1)+(I-1)*DELTA
	  END DO
	  DO J=JLO,JHI
	    CALL RDFITSROW(LU_IN,IMNUM,IPNUM,DAT,MAXSIZE,J)
	    DO I=ILO,IHI
	      IF (((EXCLUDE.AND.DAT(I).NE.0.0).OR..NOT.EXCLUDE).AND.
	1     DAT(I).GE.MINMAX(1).AND.DAT(I).LE.MINMAX(2)) THEN
	        INDEX=NINT((DAT(I)-MINMAX(1))/DELTA)+1
	        YARRAY(INDEX,1)=YARRAY(INDEX,1)+1
	      END IF
 	    END DO
	  END DO
	  NPOINTS(1)=33
	  XLABEL='Pixel Intensity'
	  YLABEL='NUMBER PER BIN'
	  TITLE='DISTRIBUTION OF VALUES'
C  One plot
	  CALL XYPLOT(XARRAY,YARRAY,50,1,NPOINTS,LINVECT,INC,LINTYPE,
	1 NSYMBOL,INVERT,COLOR,INTERACT,CROSSHAIRS,XLABEL,YLABEL,
	2 TITLE,' ',.FALSE.)
	  CALL RESETTEK
	END IF
	MORE=.FALSE.
	CALL USRINP(MORE,1,'L',1,1,'MORE=',
	1'More analysis?  (default = N)')
	IF (COMMAND.EQ.'AS') THEN
	  CALL SAO_ERASE_CURSOR(0)
	END IF
	IF (MORE) THEN
	  IF (COMMAND.EQ.'M') GO TO 50
	  IF (COMMAND.EQ.'AS') GO TO 70
	END IF
	CALL CLOSEFITS(LU_IN)
	RETURN
	END
